<p align="center">
  <img src="docs/.vuepress/public/hero-title.svg?sanitize=true">
</p>

<p align="center">
  <a href="https://chartjs-plugin-datalabels.netlify.app/guide/getting-started.html"><img src="https://img.shields.io/github/release/chartjs/chartjs-plugin-datalabels.svg?style=flat-square&maxAge=600" alt="Downloads"></a>
  <a href="https://travis-ci.org/chartjs/chartjs-plugin-datalabels"><img src="https://img.shields.io/travis/chartjs/chartjs-plugin-datalabels.svg?style=flat-square&maxAge=600" alt="Builds"></a>
  <a href="https://codeclimate.com/github/chartjs/chartjs-plugin-datalabels"><img src="https://img.shields.io/codeclimate/c/chartjs/chartjs-plugin-datalabels.svg?style=flat-square&maxAge=600" alt="Coverage"></a>
  <a href="https://github.com/chartjs/awesome"><img src="https://awesome.re/badge-flat2.svg" alt="Awesome"></a>
</p>

## Overview

Highly customizable [Chart.js](https://www.chartjs.org/) plugin that displays labels on data for any type of charts.

Requires [Chart.js](https://github.com/chartjs/Chart.js/releases) **3.x**.

## Documentation

- [Introduction](https://chartjs-plugin-datalabels.netlify.app/guide/)
- [Getting Started](https://chartjs-plugin-datalabels.netlify.app/guide/getting-started.html)
- [Options](https://chartjs-plugin-datalabels.netlify.app/guide/options.html)
- [Labels](https://chartjs-plugin-datalabels.netlify.app/guide/labels.html)
- [Positioning](https://chartjs-plugin-datalabels.netlify.app/guide/positioning.html)
- [Formatting](https://chartjs-plugin-datalabels.netlify.app/guide/formatting.html)
- [Events](https://chartjs-plugin-datalabels.netlify.app/guide/events.html)
- [TypeScript](https://chartjs-plugin-datalabels.netlify.app/guide/typescript.html)
- [Migration](https://chartjs-plugin-datalabels.netlify.app/guide/migration.html)
- [Samples](https://chartjs-plugin-datalabels.netlify.app/samples/)

## Development

You first need to install node dependencies (requires [Node.js](https://nodejs.org/)):

```
> npm install
```

The following commands will then be available from the repository root:

```
> npm run build            // build dist files
> npm run build:dev        // build and watch for changes
> npm run test             // run all tests and generate code coverage
> npm run test:dev         // run all tests and watch for changes
> npm run lint             // perform code linting
> npm run lint -- --fix    // automatically fix linting problems
> npm run docs             // generate documentation (`dist/docs`)
> npm run docs:dev         // generate documentation and watch for changes
```

## License

`chartjs-plugin-datalabels` is available under the [MIT license](LICENSE.md).
