<?php
/*** COPYRIGHT NOTICE *********************************************************
 *
 * Copyright 2009-2017 ProjeQtOr - Pascal BERNARD - support@projeqtor.org
 * Contributors : -
 *
 * This file is part of ProjeQtOr.
 * 
 * ProjeQtOr is free software: you can redistribute it and/or modify it under 
 * the terms of the GNU Affero General Public License as published by the Free 
 * Software Foundation, either version 3 of the License, or (at your option) 
 * any later version.
 * 
 * ProjeQtOr is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for 
 * more details.
 *
 * You should have received a copy of the GNU Affero General Public License along with
 * ProjeQtOr. If not, see <http://www.gnu.org/licenses/>.
 *
 * You can get complete code of ProjeQtOr, other resource, help and information
 * about contributors at http://www.projeqtor.org 
 *     
 *** DO NOT REMOVE THIS NOTICE ************************************************/

/** ===========================================================================
 * Save a note : call corresponding method in SqlElement Class
 * The new values are fetched in $_REQUEST
 */
require_once "../tool/projeqtor.php";

if (! array_key_exists('approverId',$_REQUEST)) {
  throwError('approverId parameter not found in REQUEST');
}
$approverId=$_REQUEST['approverId'];
$approverId=pq_htmlspecialchars($approverId,ENT_QUOTES,'UTF-8');
$action=RequestHandler::getValue('action');
$comment=RequestHandler::getValue('disapproveDescription');

$approver=new Approver($approverId);
if($action=='approved'){
  $approver->approved=1;
  $approver->approvedDate=date('Y-m-d H:i');
  $approver->disapproved=0;
  $approver->disapprovedDate=null;
  $approver->disapprovedComment=null;
}else{
  $approver->disapproved=1;
  $approver->disapprovedDate=date('Y-m-d H:i');
  $approver->disapprovedComment=$comment;
}
Sql::beginTransaction();
$result=$approver->save();

// Message of correct saving
displayLastOperationStatus($result);

?>