<?php
/*** COPYRIGHT NOTICE *********************************************************
 *
 * Copyright 2009-2017 ProjeQtOr - Pascal BERNARD - support@projeqtor.org
 * Contributors : -
 *
 * This file is part of ProjeQtOr.
 * 
 * ProjeQtOr is free software: you can redistribute it and/or modify it under 
 * the terms of the GNU Affero General Public License as published by the Free 
 * Software Foundation, either version 3 of the License, or (at your option) 
 * any later version.
 * 
 * ProjeQtOr is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for 
 * more details.
 *
 * You should have received a copy of the GNU Affero General Public License along with
 * ProjeQtOr. If not, see <http://www.gnu.org/licenses/>.
 *
 * You can get complete code of ProjeQtOr, other resource, help and information
 * about contributors at http://www.projeqtor.org 
 *     
 *** DO NOT REMOVE THIS NOTICE ************************************************/
require_once "../tool/projeqtor.php";
scriptLog('   ->/tool/saveWorkCategory.php');

$refId = RequestHandler::getId('refId');
$refType = RequestHandler::getValue('refType');
$workImputationName = RequestHandler::getValue('workImputationName');

Sql::beginTransaction();
$result="";

$wcategory= new WorkCategory();
$criteria = [
    'refType' => $refType,
    'refId' => $refId,
    'name' => $workImputationName,
];

$listWorkCategory = $wcategory->getSqlElementsFromCriteria($criteria);

if (!empty($listWorkCategory)) {
  $result = '<b>' . i18n('errorNameAlreadyExists') . '</b>';
  $result .= '<input type="hidden" id="lastOperation" value="control" />';
  $result .= '<input type="hidden" id="lastOperationStatus" value="INVALID" />';
  displayLastOperationStatus($result);
  return;
}

$workCategory = new WorkCategory();
$workCategory->refId=$refId;
$workCategory->refType=$refType;
$workCategory->name=$workImputationName;
$res = $workCategory->save();

if (!$result) {
  $result=$res;
}

// Message of correct saving
displayLastOperationStatus($result);

?>